#region Copyright
/*
 * Copyright 2005-2006 the Seasar Foundation and the Others.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND,
 * either express or implied. See the License for the specific language
 * governing permissions and limitations under the License.
 */
#endregion

using System;
using System.Collections;
using System.Reflection;
using Seasar.Framework.Util;

namespace Seasar.Framework.Aop.Impl
{
	/// <summary>
	/// IS2MethodInvocationC^[tFCX̎
	/// </summary>
	public class MethodInvocationImpl : IS2MethodInvocation
	{
		/// <summary>
		/// Ăяo郁\bhCX^X
		/// </summary>
		private object target_;

		/// <summary>
		/// Ăяo郁\bh
		/// </summary>
		private MethodBase method_;

		/// <summary>
		/// \bhInterceptInterceptor̔z
		/// </summary>
		private IMethodInterceptor[] interceptors_;

		/// <summary>
		/// ĂInterceptor̍ċAx
		/// </summary>
		private int interceptorsIndex_ = 1;

		/// <summary>
		/// \bḧ
		/// </summary>
		private object[] arguments_;

		/// <summary>
		/// \bhƂ̃NX̃CX^XS2ReiɊւ
		/// </summary>
		private Hashtable parameters_;

		/// <summary>
		/// RXgN^
		/// </summary>
		/// <param name="target">InterceptIuWFNg</param>
		/// <param name="method">Intercept郁\bhMethodBase</param>
		/// <param name="interceptors">\bhInterceptInterceptor</param>
		/// <param name="parameters">Intercept郁\bhƂ̃NX̃CX^XS2ReiɊւ</param>
		public MethodInvocationImpl(object target,MethodBase method,
			object[] arguments,IMethodInterceptor[] interceptors,Hashtable parameters)
		{
			if(target==null) throw new NullReferenceException("target");
			if(method==null) throw new NullReferenceException("method");
			if(interceptors==null) throw new NullReferenceException("interceptors");
			target_       = target;
			method_       = method;
			arguments_    = arguments;
			interceptors_ = interceptors;
			parameters_   = parameters;
		}

		#region IMethodInvocation o

		/// <summary>
		/// Intercept郁\bhMethod
		/// </summary>
		public MethodBase Method
		{
			get
			{
				return method_;
			}
		}

		/// <summary>
		/// InterceptIuWFNg
		/// </summary>
		public Object Target
		{
			get
			{
				return target_;
			}
		}

		/// <summary>
		/// Intercept郁\bḧ
		/// </summary>
		public Object[] Arguments
		{
			get
			{
				return arguments_;
			}
		}

		/// <summary>
		/// \bȟĂяo
		/// </summary>
		/// <remarks>
		/// Ƀ`F[ĂInterceptor΁AInterceptorĂяo܂iċAIɌĂяojB
		/// Ƀ`F[ĂInterceptor΁AInterceptĂ郁\bhs܂B
		/// <remarks>
		/// <returns>Interceptꂽ\bh̖߂l</returns>
		public Object Proceed()
		{
			while(interceptorsIndex_ < interceptors_.Length)
			{
				// Interceptor΁AInterceptorĂяo
				return interceptors_[interceptorsIndex_++].Invoke(this);
			}

            try
            {
                // Interceptꂽ\bhs
                return method_.Invoke(target_, arguments_);
            }
            catch (TargetInvocationException ex)
            {
                // InnerExceptionStackTraceۑ
                ExceptionUtil.SaveStackTraceToRemoteStackTraceString(ex.InnerException);

                // InnerExceptionthrow
                throw ex.InnerException;
            }
		}

		#endregion

		#region IS2MethodInvocation o

		/// <summary>
		/// \bhNX̌^
		/// </summary>
		public Type TargetType
		{
			get { return target_.GetType(); }
		}

		/// <summary>
		/// \bhƂ̃NX̃CX^XS2ReiɊւ
		/// </summary>
		public object GetParameter(string name)
		{
			return parameters_[name];
		}

		#endregion
	}
}
