#region Copyright
/*
 * Copyright 2005-2006 the Seasar Foundation and the Others.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND,
 * either express or implied. See the License for the specific language
 * governing permissions and limitations under the License.
 */
#endregion

using System;
using System.Collections;
using Seasar.Framework.Aop;
using Seasar.Framework.Aop.Impl;
using Seasar.Framework.Aop.Proxy;
using System.Reflection;
using Seasar.Framework.Util;

namespace Seasar.Framework.Container.Util
{
	/// <summary>
	/// AopProxyUtil ̊Tv̐łB
	/// </summary>
	public sealed class AopProxyUtil
	{
        /// <summary>
        /// ftHgAspectWeaverCX^X
        /// </summary>
        private static IAspectWeaver DEFAULT_ASPECTWEAVER_INSTANCE = new AopProxyAspectWeaver();

		private AopProxyUtil()
		{
		}

        /// <summary>
        /// AspectD荞
        /// </summary>
        /// <param name="componentDef">AspectD荞ޑΏۂ̃R|[lg`</param>
        /// <param name="constructor">RXgN^</param>
        /// <param name="args">RXgN^̈</param>
        /// <returns>AspectD荞񂾃IuWFNg</returns>
		public static object WeaveAspect(IComponentDef componentDef,ConstructorInfo constructor, object[] args)
		{
            // S2Rei擾
            IS2Container container = componentDef.Container;

            if (componentDef.ComponentType.FindInterfaces(new TypeFilter(TypeFilter), null).Length > 0)
            {
                return ConstructorUtil.NewInstance(constructor, args);
            }

            // S2ReiIAspectWeaver݂ꍇ́AS2Rei擾
            // ݂Ȃꍇ́AftHgAopProxyAspectWeavergp
            IAspectWeaver aspectWeaver = container != null && container.HasComponentDef(typeof(IAspectWeaver)) ?
                (IAspectWeaver) container.GetComponent(typeof(IAspectWeaver)) : DEFAULT_ASPECTWEAVER_INSTANCE;

            // AspectD荞
            return aspectWeaver.WeaveAspect(componentDef, constructor, args);

		}

        public static bool TypeFilter(Type type, object filterCriteria)
        {
            return type == typeof(IAspectWeaver);
        }
	}
}
